abstract class Abweichung {

   public double berechneAbweichung (double[] stichproben, double anzahl) {
     double mittelwert;
     double abweichung=0.0;

     mittelwert=berechneMittelwert(stichproben, anzahl);
     for (int i=0;i<anzahl;i++) {
         abweichung+=Math.abs(stichproben[i]-mittelwert);
     }
     abweichung*=1/anzahl;
     return abweichung;
   }

   protected abstract double berechneMittelwert (double[] stichproben, double anzahl);
}

class AbweichungArithMittel extends Abweichung {

    protected double berechneMittelwert (double[] stichproben, double anzahl) {
      double mittelwert=0.0;
      for (int i=0;i<anzahl;i++)
        mittelwert+=stichproben[i];
        mittelwert*=1/anzahl;
        return mittelwert;
    }
}

class AbweichungGeomMittel extends Abweichung {

    protected double berechneMittelwert (double[] stichproben, double anzahl) {
      double mittelwert=1.0;
      for (int i=0;i<anzahl;i++)
          mittelwert*=stichproben[i];
      mittelwert=Math.pow(mittelwert,1/anzahl);
      return mittelwert;
    }
}
