
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;



class Bibliothek{

  private List<Buch> bestand;
  static final int ARRAYLIST =1;
  static final int LINKEDLIST =2;

  Bibliothek (int variante) {
     switch(variante) {
	         case ARRAYLIST:
	             bestand = new ArrayList<Buch>();
	             break;
	         case LINKEDLIST:
	             bestand = new LinkedList<Buch>();
	             break;
	         default:
	             throw new IllegalArgumentException ("unbekanntes Argument: " + variante);
		 }
    }

  void neuesBuchAufnehmen(Buch neuesBuch,Aufnehmen algorithmus){
     algorithmus.neuesBuch(bestand, neuesBuch);
  }
}

class Buch implements Comparable<Buch> {

  private String isbn = " ";
  private String titel = " ";

  Buch (String isbn, String titel) {
     this.isbn = isbn;
     this.titel = titel;
  }

  public int compareTo(Buch b) {
      Buch buch = (Buch)b;
      return isbn.compareTo(buch.isbn());
  }

  public String isbn() {
	  return isbn;
  }

  public String toString() {
     return "ISBN: " + isbn +  ", Titel: " + titel;
  }
}


interface Aufnehmen {

	void neuesBuch (List<Buch> list, Buch b);
}

class SortiertesAufnehmen implements Aufnehmen {

	public void neuesBuch(List<Buch> list, Buch o) {
		list.add(o);
		Collections.sort(list);
	}
}

class EinfachesAufnehmen implements Aufnehmen {

	public void neuesBuch (List<Buch> list, Buch o) {
		list.add(o);
	}
}

}


